package CodeGen;

public interface IDataType {
	/**
	 * Given the type and byte length, what data type should
	 * implement this parameter?
	 * @param length byte length of parameter
	 * @return string representation of data type
	 */
	public String getType(int length);
	
	/**
	 * Given a value and a number of bytes, what should the byte
	 * array look like?
	 * @param value value to be represented
	 * @param length number of bytes
	 * @return string representation of a byte array
	 */
	public String[] getByteArrayRep(String value, int length);

	/**
	 * Generate a method, that given a byte array, return its value. 
	 * The return value of the method should of whatever type this is
	 * @param varname the name of the byte array that will be converted
	 */
	public void genByteArrayConverstion(String varname);
}
