package MDL;

import java.io.IOException;
import org.w3c.dom.Document;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;
import com.sun.org.apache.xerces.internal.parsers.DOMParser;

public class WASP_Parser implements MDLParser{
	@Override
	public Module getModule(String mdlFileLocation){
		String fileName = mdlFileLocation;

		DOMParser parser = new DOMParser();
		try {
			parser.parse(fileName);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (SAXException e) {			
			e.printStackTrace();
		}

		Document doc = parser.getDocument();

		//Get Module Attributes
		Node module = doc.getFirstChild();
		NamedNodeMap modAtr = module.getAttributes();
		String modName = modAtr.getNamedItem("name").getNodeValue();
		String modComment;
		if(modAtr.getNamedItem("comment") !=null){
			modComment = modAtr.getNamedItem("comment").getNodeValue();
		}else{
			modComment = null;
		}

		Module rMod = new Module(modName, modComment);        
		NodeList methods = module.getChildNodes();        
		for(int i = 1; i < methods.getLength(); i++){
			Node maybeMeth = methods.item(i);
			if(maybeMeth.getNodeName().equals("method")){
				NamedNodeMap methAtr = methods.item(i).getAttributes();
				String methName = methAtr.getNamedItem("name").getNodeValue();
				String methComment;
				if(methAtr.getNamedItem("comment") !=null){
					methComment = methAtr.getNamedItem("comment").getNodeValue();
				}else{
					methComment = null;
				}
				Method rmeth = new Method(methName,  methComment);
				NodeList params = methods.item(i).getChildNodes();
				for(int j = 1; j < params.getLength(); j++){
					NamedNodeMap paramAtr = params.item(j).getAttributes();
					if(paramAtr != null){
						String pName = paramAtr.getNamedItem("name").getNodeValue();
						String pType =paramAtr.getNamedItem("type").getNodeValue();
						int pLen =new Integer(paramAtr.getNamedItem("len").getNodeValue());
						String pComment = null;
						if(paramAtr.getNamedItem("comment")!= null){
							pComment = paramAtr.getNamedItem("comment").getNodeValue();
						}
						String pValue= null;
						if(paramAtr.getNamedItem("value") !=null){
							pValue = paramAtr.getNamedItem("value").getNodeValue();
						}
						rmeth.addParam(new Param(pName, pType, pLen, pComment, pValue));
					}
				}
				rMod.addMethod(rmeth);
			}
		}
		return rMod;
	}
}
